﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3
@EndOfDesignText@


Sub Process_Globals
	Type  	TEffect(Effect As Int, Internval As ULong, NumberStrips As Int)
	Type	TEffectLEDStrip(Forward As Boolean, BothDirections As Boolean, NumberLEDs As Int, LEDsStartAt As Int, Index As Int, PreviousIndex As Int, StartColorOffset As Int, NumberColors As Int)
	
	Public  IsInitialized    				As Boolean = False
	
	Public 	mEffects_Timer					As Timer
	
	Public 	mLEDStrip			 			As AdafruitNeoPixel
	Public	mLEDStrip_NumberLEDS			As Int
		
	Public	mEffect							As TEffect
	Public	mEffect_LEDStrips(100)			As TEffectLEDStrip
	Public  mEffect_LEDStrips_InUse			As Int  = 	0
		
	Public 	mEffect_Colors(100)	 			As ULong	
	Public  mEffect_Colors_InUse			As Int  = 	0
	
	Public  const DEFINE_NextEffect			As Int 	=  -1
	Public  const DEFINE_SplitInOut			As Int 	=	0
	Public  const DEFINE_LeapFrog			As Int 	=	1
	Public  const DEFINE_Twinkle			As Int 	=	2
		
	Public	const DEFINE_MaxEffects			As Int	= 	3	
End Sub


#Region DefineStrip_Initialize
'-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'	DefineStrip_Initialize	
'	
'		Clear_Strips	-	Clear the previous defined strips
'		Clear_Colors	-	Clear the previous defined colors
'-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Public  Sub DefineStrip_Initialize(Clear_Strips As Boolean, Clear_Colors As Boolean)
			If  Clear_Strips Then
				mEffect.NumberStrips	= 0
				
				mEffect_LEDStrips_InUse = 0	
			End If
			
			If  Clear_Colors Then
				mEffect_Colors_InUse 	= 0				
			End If
End Sub
#end Region

#Region DefineStrip_Section
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'	DefineStrip_Section	- Allows us to take a large strip say 150 led strip and sub divide it into smaller strips
'	
'		BothDirections	-	Which way will lights move on this strip
'		Forward			-	Which way do we start moving
'		NumberLEDs		-	How many LEDs are in this strip
'		LEDsStartAt		-	Where the LEDs start -	relative to the start of the strip 			(NOTE: -1 means same as NumberOfLEDs / allows using a large strip to define sub strips)
'		StartIndexAt	-	Where to we want to start the light show on this strip				(NOTE: -1 means same as NumberOfLEDs - pretty much you want to start at the end)
'		ColorsOJB		-	Is a array of ULongs to define the colors we want for this strip 	(NOTE: Null means use previous strip colors)
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Public  Sub DefineStrip_Section(BothDirections As Boolean, Forward As Boolean, NumberLEDs As Int, LEDsStartAt As Int, StartIndexAt As Int, ColorsOBJ As Object) As Int
	
			Dim UsingStrip As Int	
			
			UsingStrip	= mEffect_LEDStrips_InUse
			
			If  (mEffect_LEDStrips_InUse + 1) >= mEffect_LEDStrips.Length Then
				Return -1
			End If

			mEffect_LEDStrips(UsingStrip).BothDirections	= BothDirections
			mEffect_LEDStrips(UsingStrip).Forward			= Forward
			mEffect_LEDStrips(UsingStrip).NumberLEDs		= NumberLEDs
			
			If  LEDsStartAt = -1 Then
				mEffect_LEDStrips(UsingStrip).LEDsStartAt	= mEffect_LEDStrips(UsingStrip).NumberLEDs - 1
			Else				
				mEffect_LEDStrips(UsingStrip).LEDsStartAt	= LEDsStartAt					
			End If
			
			If  StartIndexAt = -1 Or StartIndexAt >= mEffect_LEDStrips(UsingStrip).NumberLEDs Then
				mEffect_LEDStrips(UsingStrip).Index			= mEffect_LEDStrips(UsingStrip).NumberLEDs - 1
			Else				
				mEffect_LEDStrips(UsingStrip).Index			= StartIndexAt
			End If
	
					
			mEffect_LEDStrips(UsingStrip).PreviousIndex		= -1
			
			'-----------------------------------------------------------------------------
			'	If we ColorsOBJ is Null then use the Colors from the last strip
			'-----------------------------------------------------------------------------
			If  ColorsOBJ = Null Then
				'-------------------------------------------------------------------------
				'  	If there is NO first strip or this is the first strip then
				'		set the Offsert and Number of colors to Zero
				'
				'	Assumes effect routine will generate a random color
				'-------------------------------------------------------------------------
				If  UsingStrip = 0 Then
					mEffect_LEDStrips(UsingStrip).StartColorOffset	= 0
					mEffect_LEDStrips(UsingStrip).NumberColors		= 0
				Else				
					mEffect_LEDStrips(UsingStrip).StartColorOffset	= mEffect_LEDStrips(UsingStrip-1).StartColorOffset
					mEffect_LEDStrips(UsingStrip).NumberColors		= mEffect_LEDStrips(UsingStrip-1).NumberColors
				End If
			Else
				Dim Colors() As ULong = ColorsOBJ
								
				mEffect_LEDStrips(UsingStrip).StartColorOffset	= AddColors(Colors)
				mEffect_LEDStrips(UsingStrip).NumberColors		= Colors.Length
			End If

			mEffect_LEDStrips_InUse 						= mEffect_LEDStrips_InUse + 1
						
			mEffect.NumberStrips							= mEffect_LEDStrips_InUse

			Log("Section:", UsingStrip, "  Number of LEDs:", NumberFormat(mEffect_LEDStrips(UsingStrip).NumberLEDs, 3, 0), "   LEDs StartAt:", NumberFormat(mEffect_LEDStrips(UsingStrip).LEDsStartAt, 3, 0))
									
			Return UsingStrip
End Sub
#end Region


#Region Effects_Timer_Tick
Private Sub Effects_Timer_Tick
'			Log("cEffects::Effects_Timer_Tick")
		
			Select 	mEffect.Effect
					Case	DEFINE_SplitInOut
							SplitInOut
							
					Case 	DEFINE_LeapFrog
							LeapFrog
							
					Case 	DEFINE_Twinkle
							Twinkle
							
			End Select
End Sub
#end Region


#Region Initialize
'------------------------------------------------------------------------------------------------
'	Initialize	- Setup the cEffects Class
'
'		PinNumber		-	The Pin we will be using to control the Strip
'		NumberLEDs		-	Number of LEDs on this Strip
'------------------------------------------------------------------------------------------------
Public  Sub Initialize(PinNumber As Int, NumberLEDs As Int)
			Log("cEffects::Initialize")

			mEffects_Timer.Initialize("Effects_Timer_Tick", 0)
			
			mLEDStrip_NumberLEDS	= NumberLEDs
				
			mLEDStrip.Initialize(NumberLEDs, PinNumber, mLEDStrip.NEO_GRB)  ' this strip ALITOVE WS2812B has GRB order
			
			mLEDStrip.Clear
			mLEDStrip.Show
End Sub
#end Region

#Region ChangeEffect
Public  Sub ChangeEffect(NextEffect As Int)
		
			mEffects_Timer.Enabled = False
			
			Dim SetEffect As Int = NextEffect
		
			If  NextEffect <> DEFINE_NextEffect Then
				If  NextEffect < 0 Or NextEffect >= DEFINE_MaxEffects Then
					Return
				End If
			Else
				If  (mEffect.Effect + 1) >= DEFINE_MaxEffects Then
					SetEffect = 0
				Else
					SetEffect = (mEffect.Effect + 1)
				End If
			End If
			
			DoEffect(SetEffect)
End Sub
#end Region

#Region DoEffect
Private	Sub DoEffect(Effect As Int)
	
			Select 	Effect
					Case 	DEFINE_SplitInOut
							Log("cEffects::DoEffect - SplitInOut")
						
							'-------------------------------------------------------------------------
							'  SplitInOut Effect
							'-------------------------------------------------------------------------
							mEffect.Effect	 			= DEFINE_SplitInOut

							DefineStrip_Initialize(True, True)
							
							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
							'  Make 4 sub strips Each Using 1/2 the string of LEDs.  2 of them start from the end and move backward and two start from the beginning and move forward and then all reverse
							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
							DefineStrip_Section(True, False, (mLEDStrip_NumberLEDS / 2),  0, -1, Array As ULong(cColors.Red, cColors.NoColor, cColors.White, cColors.NoColor, cColors.Blue, cColors.NoColor))
							DefineStrip_Section(True, True,  (mLEDStrip_NumberLEDS / 2),  0,  0, Null)
							DefineStrip_Section(True, False, (mLEDStrip_NumberLEDS / 2), -1, -1, Null)
							DefineStrip_Section(True, True,  (mLEDStrip_NumberLEDS / 2), -1,  0, Null)

							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
							'  Make 2 sub strips Each Using 1/2 the string of LEDs.  These sub strings start 1/4 of the Total LEDs in and one starts at the front and move in and the other starts at the end
							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------							
							DefineStrip_Section(True, False, (mLEDStrip_NumberLEDS / 2),  (mLEDStrip_NumberLEDS / 4), -1, Array As ULong(cColors.HotPink, cColors.NoColor, cColors.Orange, cColors.NoColor))							
							DefineStrip_Section(True, True,  (mLEDStrip_NumberLEDS / 2),  (mLEDStrip_NumberLEDS / 4),  0, Null)							
														
							mEffects_Timer.Interval		= 75
							mEffects_Timer.Enabled		= True			
							
					Case 	DEFINE_LeapFrog
							Log("cEffects::DoEffect - LeapFrog")
						
							'-------------------------------------------------------------------------
							'  LeapFrog Effect
							'-------------------------------------------------------------------------
							mEffect.Effect		 		= DEFINE_LeapFrog

							DefineStrip_Initialize(True, True)							
							
							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
							'  Make 2 sub strips Each Using all the LEDs.
							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------														
							DefineStrip_Section(True, True,  mLEDStrip_NumberLEDS,  0,  0, Array As ULong(cColors.Red, 	 cColors.NoColor, cColors.Green, cColors.NoColor))
							DefineStrip_Section(True, False, mLEDStrip_NumberLEDS,  0, -1, Array As ULong(cColors.Green, cColors.NoColor, cColors.Red,   cColors.NoColor))
							
							mEffects_Timer.Interval		= 125
							mEffects_Timer.Enabled		= True																
							
					Case 	DEFINE_Twinkle
							Log("cEffects::DoEffect - Twinkle")
						
							'-------------------------------------------------------------------------
							'  Twinkle Effect
							'-------------------------------------------------------------------------
							mEffect.Effect		 		= DEFINE_Twinkle

							DefineStrip_Initialize(True, True)							
							DefineStrip_Section(False, True,  mLEDStrip_NumberLEDS, 0, 	0, Null)
							
'							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'							'  Make 3 sub strips Each Using 1/3 of the string of LEDs.
'							'----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------																					
'							DefineStrip_Section(False, True,  mLEDStrip_NumberLEDS / 3, 0, 									0, Null)
'							DefineStrip_Section(False, True,  mLEDStrip_NumberLEDS / 3, ((mLEDStrip_NumberLEDS / 3) * 1),	0, Null)
'							DefineStrip_Section(False, True,  mLEDStrip_NumberLEDS / 3, ((mLEDStrip_NumberLEDS / 3) * 2), 	0, Null)
							
							mEffects_Timer.Interval		= 25	'  At this speed it looks like there are multiple leds lit but there is only 1
							mEffects_Timer.Enabled		= True																							
			End Select
			
End Sub
#end Region

#Region SplitInOut
Public  Sub SplitInOut()	
			'-------------------------------------------------------------------------------------------------------------------------
			'	SplitInOut assumes we are splitting the string in half and start moving from the inside to outside then back inside
			'-------------------------------------------------------------------------------------------------------------------------			
			For WhichStrip = 0 To mEffect.NumberStrips-1
				If  mEffect_LEDStrips(WhichStrip).NumberColors <= 0 Then
					Continue
				End If
				
				Dim ColorOffset As Int = mEffect_LEDStrips(WhichStrip).NumberColors-1
				
				For WhichColor = 0 To mEffect_LEDStrips(WhichStrip).NumberColors-1	
					If  mEffect_LEDStrips(WhichStrip).Forward Then
						If  (mEffect_LEDStrips(WhichStrip).NumberLEDs - (mEffect_LEDStrips(WhichStrip).Index + WhichColor)) >= 0 Then
							mLEDStrip.SetPixelColor3((mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).Index + WhichColor), mEffect_Colors(mEffect_LEDStrips(WhichStrip).StartColorOffset + (ColorOffset - WhichColor)))
						End If							
					Else
						If  (mEffect_LEDStrips(WhichStrip).NumberLEDs - (mEffect_LEDStrips(WhichStrip).Index + WhichColor)) >= 0 Then
							mLEDStrip.SetPixelColor3((mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).Index + WhichColor), mEffect_Colors(mEffect_LEDStrips(WhichStrip).StartColorOffset + WhichColor))
						End If														
					End If						
				Next
			Next
									
			mLEDStrip.Show
			mLEDStrip.Clear
									
			Effect_Increment
				
			Return
End Sub
#end Region

#Region LeapFrog
Public  Sub LeapFrog
			'-------------------------------------------------------------------------------------------------------------------------			
			'	LeapFrog starts from one end and leaps the next color over the previous color
			'-------------------------------------------------------------------------------------------------------------------------				
			
			For WhichStrip = 0 To mEffect.NumberStrips-1	
				If  mEffect_LEDStrips(WhichStrip).NumberColors <= 0 Then
					Continue
				End If
					
				Dim WhichColor As Int =	(mEffect_LEDStrips(WhichStrip).Index Mod mEffect_LEDStrips(WhichStrip).NumberColors)

				If  mEffect_LEDStrips(WhichStrip).PreviousIndex >= 0 And mEffect_LEDStrips(WhichStrip).PreviousIndex < mEffect_LEDStrips(WhichStrip).NumberLEDs Then
					mLEDStrip.SetPixelColor3(mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).PreviousIndex, cColors.NoColor)						
				End If

				mLEDStrip.SetPixelColor3(mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).Index, mEffect_Colors(mEffect_LEDStrips(WhichStrip).StartColorOffset + WhichColor))

				If  mEffect_LEDStrips(WhichStrip).Forward Then
					mEffect_LEDStrips(WhichStrip).PreviousIndex = (mEffect_LEDStrips(WhichStrip).Index - mEffect_LEDStrips(WhichStrip).NumberColors) + 1
				Else
					mEffect_LEDStrips(WhichStrip).PreviousIndex = (mEffect_LEDStrips(WhichStrip).Index + mEffect_LEDStrips(WhichStrip).NumberColors) - 1
				End If
			Next					

			mLEDStrip.Show
									
			Effect_Increment			
				
			Return	
End Sub
#end region

#Region Twinkle
Public  Sub Twinkle()	
			'-------------------------------------------------------------------------------------------------------------------------
			'	Twinkle Randomly Flash on colors
			'-------------------------------------------------------------------------------------------------------------------------			
			For WhichStrip = 0 To mEffect.NumberStrips-1
				Dim RColor	 	As Byte
				Dim GColor	 	As Byte
				Dim BColor	 	As Byte
				
				
				mEffect_LEDStrips(WhichStrip).Index = Rnd(0, mEffect_LEDStrips(WhichStrip).NumberLEDs - 1)
				
				'---------------------------------------------------------------------------------------------------------------------
				'  	If Colors have been set the randomly pick one of them
				'	Otherwise generate a random color
				'---------------------------------------------------------------------------------------------------------------------
				If  mEffect_LEDStrips(WhichStrip).NumberColors <= 0 Then
					RColor	= Rnd(0, 255)
					GColor	= Rnd(0, 255)
					BColor	= Rnd(0, 255)
				Else					
					Dim BC				As ByteConverter
										
					Dim ColorBytes()	As Byte
					
					If  mEffect_LEDStrips(WhichStrip).NumberColors > 1 Then
						ColorBytes = BC.ULongsToBytes(Array As ULong(mEffect_Colors(mEffect_LEDStrips(WhichStrip).StartColorOffset + (Rnd(0, mEffect_LEDStrips(WhichStrip).NumberColors-1)))))
					Else
						ColorBytes = BC.ULongsToBytes(Array As ULong(mEffect_Colors(mEffect_LEDStrips(WhichStrip).StartColorOffset)))
					End If
					
					RColor = ColorBytes(1)
					GColor = ColorBytes(2)
					BColor = ColorBytes(3)
				End If
					
				If  mEffect_LEDStrips(WhichStrip).PreviousIndex >= 0 And mEffect_LEDStrips(WhichStrip).PreviousIndex < mEffect_LEDStrips(WhichStrip).NumberLEDs Then
					mLEDStrip.SetPixelColor3(mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).PreviousIndex, cColors.NoColor)															
				End If

				If  RColor <> 0 Or GColor <> 0 Or BColor <> 0 Then				
					mLEDStrip.SetPixelColor(mEffect_LEDStrips(WhichStrip).LEDsStartAt + mEffect_LEDStrips(WhichStrip).Index, RColor, GColor, BColor)
				End If

				mEffect_LEDStrips(WhichStrip).PreviousIndex = mEffect_LEDStrips(WhichStrip).Index
			Next
									
			mLEDStrip.Show
				
			Return
End Sub
#end Region

#Region AddColors
Public  Sub AddColors(Colors() As ULong) As Int

			Dim Offset 	As Int

			Dim ColorMatches	As Int		

			'----------------------------------------------------------------------------------------------
			'  	Before adding colors
			'		Look to see if there is a set of colors that match what we are passing	
			'----------------------------------------------------------------------------------------------
			For Offset = 0 To mEffect_Colors_InUse - 1
				ColorMatches = 0
						
				For ColorEntry = 0 To Colors.Length - 1
					If  (Offset + ColorEntry) >= mEffect_Colors_InUse Then
						Exit
					End If
							
					If  mEffect_Colors(Offset + ColorEntry) <> Colors(ColorEntry) Then
						Exit
					End If
						
					ColorMatches = ColorMatches + 1	
				Next
						
				'------------------------------------------------------------
				'  If we matched ALL the colors then found right entry
				'------------------------------------------------------------						
				If  ColorMatches = Colors.Length Then
					Log("SetColors - Color Match Found")
					Return Offset
				End If
			Next
			
			'----------------------------------------------------------------------------------------------
			'  Check we don't go over preallocated length
			'----------------------------------------------------------------------------------------------
			If  (mEffect_Colors_InUse + Colors.Length) >= mEffect_Colors.Length Then
				Return -1
			End If
			
			Log("Adding Colors")
			
			Offset 	= mEffect_Colors_InUse
							
			For i = 0 To Colors.Length-1
				mEffect_Colors(Offset + i) = Colors(i)
			Next

			mEffect_Colors_InUse = mEffect_Colors_InUse + Colors.Length
			
			Return Offset
End Sub
#end Region

#Region Effect_Increment
Public  Sub Effect_Increment
			For WhichStrip = 0 To mEffect.NumberStrips-1	
				If  mEffect_LEDStrips(WhichStrip).Forward Then
					mEffect_LEDStrips(WhichStrip).Index	= mEffect_LEDStrips(WhichStrip).Index + 1
				
					If  mEffect_LEDStrips(WhichStrip).Index > mEffect_LEDStrips(WhichStrip).NumberLEDs Then
						Effect_Complete(WhichStrip)	
					End If				
				Else
					mEffect_LEDStrips(WhichStrip).Index	= mEffect_LEDStrips(WhichStrip).Index - 1			
				
					If  mEffect_LEDStrips(WhichStrip).Index < 0 Then
						Effect_Complete(WhichStrip)	
					End If								
				End If
			Next
End Sub
#end Region

#Region Effect_Complete
Public  Sub Effect_Complete(WhichStrip As Int)
			If  WhichStrip >= 0 And WhichStrip < mEffect.NumberStrips Then
				If  mEffect_LEDStrips(WhichStrip).BothDirections Then
					If  mEffect_LEDStrips(WhichStrip).Forward Then
						mEffect_LEDStrips(WhichStrip).Index  	= mEffect_LEDStrips(WhichStrip).NumberLEDs - 1
						mEffect_LEDStrips(WhichStrip).Forward 	= False
					Else
						mEffect_LEDStrips(WhichStrip).Index		= 0
						mEffect_LEDStrips(WhichStrip).Forward 	= True
					End If									
				Else
					If  mEffect_LEDStrips(WhichStrip).Forward Then
						mEffect_LEDStrips(WhichStrip).Index 	= 0
					Else
						mEffect_LEDStrips(WhichStrip).Index 	= mEffect_LEDStrips(WhichStrip).NumberLEDs - 1
					End If
				End If				
			End If
End Sub
#end Region